from oerppy.scripting import Script


class TableMetadata(Script):
    """
    Get the table metadata corresponding to the given OpenERP entity.
    """
    def get_option_parser(self):
        parser = super(TableMetadata, self).get_option_parser()
        parser.add_option(
            "-e", "--openerp-entity", dest="entity", action="store",
            help="the OpenERP dotted entity name to query")
        return parser

    def run(self):
        # we need to set purge to true here, since the options will have
        # already been gotten by the parent class at this time, and we need the
        # options of this class added to those
        options = self.get_options(purge=True)
        parser = self.get_option_parser()
        if options.entity == None:
            parser.error("You must supply the -e or --openerp-entity option. "
                         "For more information, use --help.")
        addon = self.service.get_addon("canonical")
        print addon.get_entity_fields(options.entity)
        
