import unittest

from oerppy.addons.hr import model


employee_results = [
    {"name": "Bob",
     "user_id": [314, "Bob"],
     "department_id": [1, "Crypto"],
     "resource_id": [34, "Bob"]},
    {"name": "Alice",
     "user_id": [315, "Alice"],
     "department_id": [2, "Maths"],
     "resource_id": [37, "Alice"]},
    {"name": "Carol",
     "user_id": [316, False],
     "department_id": False,
     "resource_id": [42, "Carol"]},
    ]


class HRModelTestCase(unittest.TestCase):

    def test_hr_employee(self):
        employee = model.Employee(employee_results[1])
        self.assertEqual(employee.user.key, 315)
        self.assertEqual(employee.user.value, "Alice")
        self.assertEqual(employee.name, "Alice")
        self.assertEqual(employee.department.key, 2)
        self.assertEqual(employee.department.value, "Maths")
        self.assertEqual(employee.resource.key, 37)

    def test_hr_employee_set(self):
        results = model.EmployeeSet(employee_results)
        self.assertEqual(len(results), 3)
        user = results.get_user(314)
        self.assertEqual(user.name, "Bob")
        table = results.build_department_lookup_table()
        self.assertEqual(table.get(315), "Maths")
        self.assertEqual(table.get(316), None)
