from oerppy import query
from oerppy.addons.project import model


class ProjectQuery(query.Query):
    """
    """
    def get_project(self, id=None, name=""):
        if name:
            query = [('name','=',name)]
        elif id:
            query = [('id','=',id)]
        raw_results = self.client.searchfields(
            entity='project.project',
            query=query,
            fields=[])
        return model.ProjectSet(raw_results).get_first()

    def get_project_id(self, project_name):
        project = self.get_project(name=project_name)
        if project:
            return project.id

    def get_project_user_ids(self, project_name="", project_id=None):
        if project_name:
            query = [('name', '=', project_name)]
        elif project_id:
            query = [('id', '=', project_id)]
        else:
            query = []
        raw_results = self.client.searchfields(
            entity='project.project',
            query=query,
            fields=['members'])
        result = model.ProjectSet(raw_results).get_first()
        return result.members

    def get_project_names(self):
        raw_results = self.client.searchfields(
            entity='project.project',
            query=[],
            fields=['name'])
        results = model.ProjectSet(raw_results)
        return [x.name for x in results]

    def timesheet_hours(self, domains):
        raw_results = self.client.searchfields(
            entity="project.task.work",
            query=domains,
            fields=[])
        return model.TaskWorkSet(raw_results, self.get_user_dept())

    def get_all_timeentry_weeks(self):
        """
        Get timeentry data since we've been tracking it.
        """
        raw_results = self.client.searchfields(
            entity='project.timeentry.week',
            query=[],
            fields=[])
        return model.TimeEntryWeekSet(raw_results)
