import yaml

from oerppy import util


def get_config_data(default_config="", dest_dir=""):
    """
    Get the YAML configuration data.

    This function's parameters are used only for testing purposes.
    """
    return yaml.load(util.read_config(default_config, dest_dir))


def get_server(host, database, default_config="", dest_dir=""):
    """
    Get the configuration data for a particular OpenERP server.

    This function's parameters are used only for testing purposes.
    """
    data = get_config_data(default_config, dest_dir)
    for server in data.get("servers"):
        if (server.get("host"), server.get("database")) == (host, database):
            return server
    return {}
