import csv


def setup_csv_dictwriter(data, file_handle):
    header_row = data[0].keys()
    writer = csv.DictWriter(file_handle, header_row)
    writer.writerow(dict(zip(header_row, header_row)))
    return writer


def setup_csv_writer(file_handle):
    return csv.writer(file_handle)


def export_csv(data, file_handle):
    """
    Export the records to a CSV file.
    """
    if not data:
        return
    # Do some dispatching...
    if isinstance(data[0], dict):
        writer = setup_csv_dictwriter(data, file_handle)
    else:
        writer = setup_csv_writer(file_handle)
    # Output the records
    for row in data:
        if isinstance(row, basestring):
            writer.writerow([row])
        else:
            writer.writerow(row)
