class Field(object):
    """
    An object representing a data point.
    """
    def __init__(self, data):
        self.value = value
    def __repr__(self):
        return self.value or ""
    def __str__(self):
        return str(self.value)


class KeyValuePairField(Field):
    """
    An object representing a field that has an ID and a string value.
    """
    def __init__(self, data):
        if not data:
            data = (None, None)
        (self.key, self.value) = data


class Model(object):
    """
    Base class for representing result sets and result data.
    """
    def __init__(self, row):
        raise NotImplementedError


class ResultSet(list):
    """
    Base class for collections of models, all together representing result sets
    in queries to the OpenERP server.
    """
    model = Model

    def __init__(self, results, *args, **kwds):
        if not results:
            return
        for row in results:
            try:
                self.append(self.model(row, *args, **kwds))
            except Exception, error:
                print error
                import pdb;pdb.set_trace()

    def get_first(self):
        return self[0]


class User(Model):
    """
    This is an object model that maps to search results from OpenERP's
    "res.users" entity.
    """
    def __init__(self, row):
        self.id = row.get("id")
        self.active = row.get("active")
        self.company_ids = row.get("company_ids")
        self.menu_tips = row.get("menu_tips")
        self.date = row.get("date")
        self.context_lang = row.get("context_lang")
        self.password = row.get("password")
        self.context_tz = row.get("context_tz")
        self.name = row.get("name")
        self.signature = row.get("signature")
        self.login = row.get("login")
        self.user_email = row.get("user_email")
        self.view = row.get("view")
        self.groups_id = row.get("groups_id")
        # The following are key/value pairs, each with .key and .value
        # attributes
        self.company = KeyValuePairField(row.get("company_id"))
        self.address = KeyValuePairField(row.get("address_id")) 
        self.action = KeyValuePairField(row.get("action_id"))
        self.menu = KeyValuePairField(row.get("menu_id"))
        self.context_project = KeyValuePairField(
            row.get("context_project_id"))
        self.context_department = KeyValuePairField(
            row.get("context_department_id"))
        # XXX I haven't used these; they need to be checked by someone who has
        # and then given the appropriate field class.
        # XXX I'm assuming these would just be simple values:
        self.new_password = None
        self.email = None


class UsersSet(ResultSet):
    """
    An object for collecting User records together.
    """
    model = User

    def get_user(self, user_id):
        for user in self:
            if user.id == user_id:
                return user
