import unittest

from oerppy import model


user_results = [
 {'action_id': [418, 'Weekly Timesheet'],
  'active': True,
  'address_id': [185, 'Alice'],
  'category_ids': [1],
  'company_id': [1, 'The Company, Inc.'],
  'company_ids': [1],
  'context_department_id': False,
  'context_lang': 'en_US',
  'context_project_id': False,
  'context_tz': False,
  'date': '2011-04-25 15:03:51.386437',
  'email': False,
  'groups_id': [22, 27, 3],
  'id': 84,
  'login': 'alice@company.com',
  'menu_id': [1, 'Menu'],
  'menu_tips': True,
  'name': 'Alice',
  'new_password': [],
  'password': 's3cr3t',
  'signature': False,
  'user_email': 'alice@company.com',
  'view': 'simple'},
 {'action_id': [380, 'Administration Dashboard'],
  'active': True,
  'address_id': [1,
                 '101 Main St.'],
  'category_ids': [],
  'company_id': [1, 'The Company, Inc.'],
  'company_ids': [1],
  'context_department_id': False,
  'context_lang': 'en_US',
  'context_project_id': False,
  'context_tz': 'Europe/London',
  'date': '2011-06-03 08:37:00.67816',
  'email': False,
  'groups_id': [17,
                16,
                18,
                2,
                1,
                28,
                29,
                30,
                24,
                25,
                26,
                23,
                14,
                15,
                3,
                20,
                21,
                7,
                8,
                13,
                27,
                22,
                9,
                11,
                32,
                33,
                5],
  'id': 1,
  'login': 'admin',
  'menu_id': [1, 'Menu'],
  'menu_tips': False,
  'name': 'Administrator',
  'new_password': [],
  'password': 'th3p455',
  'signature': 'Administrator',
  'user_email': 'bob@company.com',
  'view': 'extended'}]


class UsersModelTestCase(unittest.TestCase):

    def test_user(self):
        user = model.User(user_results[0])
        self.assertEqual(user.id, 84)
        self.assertEqual(user.name, "Alice")
        self.assertEqual(user.company.key, 1)
        self.assertEqual(user.company.value, "The Company, Inc.")
        self.assertEqual(user.user_email, "alice@company.com")

    def test_users_set(self):
        results = model.UsersSet(user_results)
        self.assertEqual(len(results), 2)
        user = results.get_user(84)
        self.assertEqual(user.name, "Alice")
